<?php



// Q-registerations 2.5 build:20110627



session_start();



if ( isset($_GET['language']) ) $_SESSION['qtr_setup_lang']=$_GET['language'];

if ( !isset($_SESSION['qtr_setup_lang']) ) $_SESSION['qtr_setup_lang']='en';

if ( !file_exists('qtr_lang_'.$_SESSION['qtr_setup_lang'].'.php') ) $_SESSION['qtr_setup_lang']='en';



include('qtr_lang_'.$_SESSION['qtr_setup_lang'].'.php');

include('../bin/config.php');



$strAppl = 'Q-registerations';

$strPrevUrl = 'qtr_setup.php';

$strNextUrl = 'qtr_setup_2.php';

$strPrevLabel= $L['Back'];

$strNextLabel= $L['Next'];

$strError = '';



// --------

// HTML START

// --------



include('qtr_setup_hd.php');



echo '

<table cellspacing="0">

<tr valign="top">

<td width="475" style="padding:0px">';



// --------

// SUBMITTED

// --------



if ( isset($_POST['ok']) )

{

  include('../bin/qt_lib_db.php');



  $qtr_dbsystem = strip_tags(trim($_POST['qtr_dbsystem']));

  $qtr_host     = strip_tags(trim($_POST['qtr_host']));

  $qtr_database = strip_tags(trim($_POST['qtr_database']));

  $qtr_prefix   = strip_tags(trim($_POST['qtr_prefix']));

  $qtr_user     = strip_tags(trim($_POST['qtr_user']));

  $qtr_pwd      = strip_tags(trim($_POST['qtr_pwd']));

  $qtr_port     = strip_tags(trim($_POST['qtr_port']));

  $qtr_dsn      = strip_tags(trim($_POST['qtr_dsn']));

  $str = strip_tags(trim($_POST['qtr_dbo_login']));

  if ( $str!='') $_SESSION['qtr_dbologin'] = $str;

  $str = strip_tags(trim($_POST['qtr_dbo_pswrd']));

  if ( $str!='') $_SESSION['qtr_dbopwd'] = $str;



  // Test Connection



  if ( isset($_SESSION['qtr_dbologin']) )

  {

    $oDB = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$_SESSION['qtr_dbologin'],$_SESSION['qtr_dbopwd'],$qtr_port,$qtr_dsn);

  }

  else

  {

    $oDB = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);

  }



  if ( empty($oDB->error) )

  {

    echo '<div class="setup_ok">',$L['S_connect'],'</div>';

  }

  else

  {

    echo '<div class="setup_err">',sprintf ($L['E_connect'],$qtr_database,$qtr_host),'</div>';

  }



  // Save Connection



  $strFilename = '../bin/config.php';

  $content = '<?php

  $qtr_dbsystem = "'.$qtr_dbsystem.'";

  $qtr_host = "'.$qtr_host.'";

  $qtr_database = "'.$qtr_database.'";

  $qtr_prefix = "'.$qtr_prefix.'";

  $qtr_user = "'.$qtr_user.'";

  $qtr_pwd = "'.$qtr_pwd.'";

  $qtr_port = "'.$qtr_port.'";

  $qtr_dsn = "'.$qtr_dsn.'";

  $qtr_install = "'.date('Y-m-d').'";

  ?>';



  if ( !is_writable($strFilename) ) $strError="Impossible to write into the file [$strFilename].";

  if ( empty($strError) )

  {

  if ( !$handle = fopen($strFilename, 'w') ) $strError="Impossible to open the file [$strFilename].";

  }

  if ( empty($strError) )

  {

  if ( fwrite($handle, $content)===FALSE ) $strError="Impossible to write into the file [$strFilename].";

  fclose($handle);

  }



  if ( empty($strError) )

  {

    echo '<div class="setup_ok">',$L['S_save'],'</div>';

  }

  else

  {

    echo '<div class="setup_err">',$strError,$L['E_save'],'</div>';

  }

}



echo '<form method="post" name="install" action="qtr_setup_1.php">

<table cellspacing="0" cellpadding="5">

<tr>

<td colspan="2"><h2>',$L['Connection_db'],'</h2><br/></td>

</tr>

';

echo '<tr>

<td><label for="qtr_dbsystem">',$L['Database_type'],'</label></td>

<td><select id="qtr_dbsystem" name="qtr_dbsystem">

<option value="mysql"',($qtr_dbsystem=='mysql' ? ' selected="selected"' : ''),'>MySQL (v5 or next)</option>

<option value="mysql4"',($qtr_dbsystem=='mysql4' ? ' selected="selected"' : ''),'>MySQL (v4)</option>

<option value="sqlsrv"',($qtr_dbsystem=='sqlsrv' ? ' selected="selected"' : ''),'>SQL server, Microsoft driver</option>

<option value="mssql"',($qtr_dbsystem=='mssql' ? ' selected="selected"' : ''),'>SQL server, Php driver (old)</option>

<option value="pg"'.($qtr_dbsystem=='pg' ? 'selected="selected"' : ''),'>PostgreSQL</option>

<option value="ibase"'.($qtr_dbsystem=='ibase' ? 'selected="selected"' : ''),'>Firebird</option>

<option value="sqlite"'.($qtr_dbsystem=='sqlite' ? 'selected="selected"' : ''),'>SQLite</option>

<option value="db2"',($qtr_dbsystem=='db2' ? ' selected="selected"' : ''),'>IBM DB2</option>

<option value="oci"',($qtr_dbsystem=='oci' ? ' selected="selected"' : ''),'>Oracle</option>

</select></td>

</tr>

';

echo '<tr>

<td><label for="qtr_host">',$L['Database_host'],'</label></td>

<td>

<input type="text" name="qtr_host" id="qtr_host" value="',$qtr_host,'" size="15" maxlength="100"/>

<input type="text" name="qtr_port" value="',$qtr_port,'" size="5" maxlength="20"/>

<input type="text" name="qtr_dsn" value="',$qtr_dsn,'" size="8" maxlength="100"/>

</td>

</tr>

<tr>

<td><label for="qtr_database">',$L['Database_name'],'</label></td>

<td><input type="text" id="qtr_database" name="qtr_database" value="',$qtr_database,'" size="15" maxlength="100"/></td>

</tr>

<tr>

<td><label for="qtr_prefix">',$L['Table_prefix'],'</label></td>

<td><input type="text" id="qtr_prefix" name="qtr_prefix" value="',$qtr_prefix,'" size="15" maxlength="100"/></td>

</tr>

<tr>

<td><label for="qtr_user">',$L['Database_user'],'</label></td>

<td>

<input id="qtr_user" name="qtr_user" value="',$qtr_user,'" size="15" maxlength="100"/>

<input type="password" name="qtr_pwd" value="',$qtr_pwd,'" size="15" maxlength="100"/>

</td>

</tr>

<tr>

<td colspan="2" style="background-color:#CCCCCC"><span class="small">',$L['Htablecreator'],'</span></td>

</tr>

<tr>

<td style="background-color:#CCCCCC"><label for="qtr_dbo_login">Table creator (login/password)</label></td>

<td style="background-color:#CCCCCC">

<input type="text" id="qtr_dbo_login" name="qtr_dbo_login" value="',(isset($_SESSION['qtr_dbologin']) ? $_SESSION['qtr_dbologin'] : ''),'" size="15" maxlength="100"/>

<input type="password" name="qtr_dbo_pswrd" value="',(isset($_SESSION['qtr_dbopwd']) ? $_SESSION['qtr_dbopwd'] : ''),'" size="15" maxlength="100"/>

</td>

</tr>

<tr>

<td colspan="2">&nbsp;</td>

</tr>

<tr>

<td colspan="2" style="text-align:center"><input type="submit" name="ok" value="',$L['Save'],'"/></td>

</tr>



</table>

</form>

<span class="small">',$L['Upgrade'],'</span>';



echo '

</td>

<td class="hidden"><div class="setup_help">',$L['Help_1'],'</div></td>

</tr>

</table>

';



// --------

// HTML END

// --------



include('qtr_setup_ft.php');