<?php

// Q-registerations 2.5 build:20110627

switch($oDB->type)
{

case 'mysql4':
case 'mysql':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1),
  name varchar(24),
  icon varchar(24),
  mailto varchar(255),
  color varchar(24),
  PRIMARY KEY (id)
  )';
  break;

case 'sqlsrv':
case 'mssql':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1) NOT NULL CONSTRAINT pk_'.$qtr_prefix.'qtrstatus PRIMARY KEY,
  name varchar(24) NULL,
  icon varchar(24) NULL,
  mailto varchar(255) NULL,
  color varchar(24) NULL
  )';
  break;

case 'pg':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1),
  name varchar(24),
  icon varchar(24),
  mailto varchar(255),
  color varchar(24),
  PRIMARY KEY (id)
  )';
  break;

case 'ibase':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1),
  name varchar(24),
  icon varchar(24),
  mailto varchar(255),
  color varchar(24),
  PRIMARY KEY (id)
  )';
  break;

case 'sqlite':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id text,
  name text,
  icon text,
  mailto text,
  color text,
  PRIMARY KEY (id)
  )';
  break;

case 'db2':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1) NOT NULL,
  name varchar(24),
  icon varchar(24),
  mailto varchar(255),
  color varchar(24),
  PRIMARY KEY (id)
  )';
  break;

case 'oci':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrstatus (
  id char(1),
  name varchar2(24),
  icon varchar2(24),
  mailto varchar2(255),
  color varchar2(24),
  CONSTRAINT pk_'.$qtr_prefix.'qtrstatus PRIMARY KEY (id))';
  break;

default:
  die("Database type [{$oDB->type}] not supported... Must be mysql, sqlsrv, mssql, pg, oci, sqlite, ibase, db2");

}

echo '<span style="color:blue;">';
$b=$oDB->Query($strQ);
echo '</span>';

if ( !empty($oDB->error) || !$b )
{
  echo '<div class="setup_err">',sprintf ($L['E_install'],$qtr_prefix.'qtrstatus',$qtr_database,$qtr_user),'</div>';
  echo '<br/><table cellspacing="0" class="button"><tr><td></td><td class="button" style="width:120px">&nbsp;<a href="qtr_setup_1.php">',$L['Restart'],'</a>&nbsp;</td></tr></table>';
  exit;
}

// add default values
$oDB->Query('INSERT INTO '.$qtr_prefix.'qtrstatus (id,name,icon) VALUES ("A","submitted","ico_status0.gif")');
$oDB->Query('INSERT INTO '.$qtr_prefix.'qtrstatus (id,name,icon) VALUES ("B","in_process","ico_status2.gif")');
$oDB->Query('INSERT INTO '.$qtr_prefix.'qtrstatus (id,name,icon,color) VALUES ("C","completed","ico_status4.gif","#AFED9A")');
$oDB->Query('INSERT INTO '.$qtr_prefix.'qtrstatus (id,name,icon,color) VALUES ("X","cancelled","ico_status8.gif","#FF8181")');
$oDB->Query('INSERT INTO '.$qtr_prefix.'qtrstatus (id,name,icon,color) VALUES ("Z","closed","ico_topic_t_1.gif","#EEEEEE")');