<?php

// Q-registrations 2.5 build:20110627

include('qtr_stats_inc_d.php');
 
// Display title & option

echo '<table class="hidden" cellspacing="0">';
echo '<tr class="hidden" style="vertical-align:middle;">';
echo '<td><h2>',$y,($s>=0 ? ' '.$oVIP->sections[$s] : ''),($type=='I' ? ' '.$L['Inspections'] : ''),($type=='A' ? ' '.$L['Newss'] : ''),(empty($tag) ? '' : ', '.$L['Withtag'].' '.str_replace(';',' '.$L['or'].' ',$tag)),'</h2></td>',N;
echo '<td class="small" style="text-align:right">',implode(' &middot; ',$arrMenuTime),'</td>';
echo '</tr></table>
';

// Display table header
echo '<table class="data_t" cellspacing="0">
<tr class="data_t">
<td class="colhd" style="width:100px">&nbsp;</td>
<td class="colhd" style="width:14px">&nbsp;</td>
';
switch($ch['time'])
{
case 'q': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',str_replace(' ','<br/>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<td class="colhd" style="text-align:center;"><b>',($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']),'</b></td>
</tr>';

// DISPLAY NEW TOPIC

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['New_topics'],'</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:#000066;width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrN[$y][$intBt]) ? $arrN[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrNs[$y],'</b></td></tr>',N;

// DISPLAY CLOSED TOPICS

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Closed_topics'],'</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:#990099;width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrC[$y][$intBt]) ? $arrC[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrCs[$y],'</b></td></tr>',N;

// DISPLAY BACKLOG

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Backlog'],'</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:#009999;width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrT[$y][$intBt]) ? $arrT[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrTs[$y],'</b></td></tr>',N;

echo '</table>
';

// After values display change the null values to zero to be able to make charts

foreach($arrYears as $intYear)
{
$arrT[$intYear] = QTarrayzero($arrT[$intYear]);
$arrN[$intYear] = QTarrayzero($arrN[$intYear]);
$arrC[$intYear] = QTarrayzero($arrC[$intYear]);
}

// PCHART OR CHART

if ( file_exists('pChart/pChart.class') && file_exists('pChart/pData.class')  && !isset($_GET['oldgraph']) )
{
  // absciseLabel
  $arrA = array();
  switch($ch['time'])
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]='Q'.$i; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=substr($L['dateMM'][$i],0,2); } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=substr(DateAdd($strTendaysago,$i,'day'),-2,2); } break;
  }

  // Standard inclusions and prepare CACHE
  include('pChart/pData.class');
  include('pChart/pChart.class');
  if ( file_exists('pChart/pCache.class') )
  {
  include('pChart/pCache.class');
  $Cache = new pCache('pChart/Cache/'); // variable must be created here (re-used as global in QTpchart function)
  CheckChartCache($Cache);
  }

  // Check cache, clear cache if to much files
  $intHandle = opendir('pChart/Cache');
  $i = 0;
  while ( false!==($strFile = readdir($intHandle)) ) $i++;
  closedir($intHandle);
  if ( $i>60 || isset($_GET['clearcache']) ) $Cache->ClearCache();

  // -------
  // Graphs
  // -------
  
  $lang = GetIso();
  // charttitle,abscise,dataset,datasetname,graphoptions,filename,color,cumul
  // note: language code is added to the filename to enable refreshing cached-graph when user change language.
  $strChart1 = QTpchart(
    $L['New_topics'].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrN[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'1'.$y.implode('',$ch).$lang,
    1);
  $strChart2 = QTpchart(
    $L['Closed_topics'].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrC[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'2'.$y.implode('',$ch).$lang,
    2);
  $strChart3 = QTpchart(
    $L['Backlog'].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrT[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'3'.$y.implode('',$ch).$lang,
    3);
  $strChart4 = QTpchart(
    $L['Backlog_cumul'].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrT[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'4'.$y.implode('',$ch).$lang,
    3,true); //cumul

  // -------
  // DISPLAY
  // -------

  echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuType),'</p>';
  
  echo '<img id="chart1" src="'.$strChart1.'" /><img id="chart2" src="'.$strChart2.'" /><img id="chart3" src="'.$strChart3.'" /><img id="chart4" src="'.$strChart4.'" /><br />',N;

}
elseif ( file_exists('bin/qt_lib_graph.php') && file_exists($_SESSION[QT]['skin_dir'].'/qtr_main2.css') )
{
    
  echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuValue),'</p>';
  
  echo '<table class="data_t" cellspacing="0">',N;

  echo '<tr class="data_t">',N;
  echo '<td class="colct" style="width:355px">',N;

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrN[$y])),350,100,QTroof(QTpercent($arrN[$y])),2,'P',$L['New_topics'].' (%)');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrN[$y]),320,100,QTroof($arrN[$y]),2,true,$L['New_topics']);
  }

  echo '</td>',N;  
  echo '<td class="colct">&nbsp;</td>',N;
  echo '<td class="colct" style="width:355px">',N;
  
  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrC[$y])),350,100,QTroof(QTpercent($arrC[$y])),2,'P',$L['Closed_topics'].' (%)','','2');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrC[$y]),320,100,QTroof($arrC[$y]),2,true,$L['Closed_topics'],'','2');
  }

  echo '</td>',N;
  echo '</tr>',N;  

  echo '<tr class="data_o">',N;
  echo '<td class="colct" style="width:355px">',N;

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrT[$y])),350,100,100,2,'P',$L['Backlog'].' (%)','','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrT[$y]),320,100,QTroof($arrT[$y]),2,true,$L['Backlog'],'','3');
  }
  
  echo '</td>',N;
  echo '<td class="colct">&nbsp;</td>',N;
  echo '<td class="colct" style="width:355px">',N;

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTcumul(QTpercent($arrT[$y]))),350,100,100,2,'P',$L['Backlog_cumul'].' (%)','','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,QTcumul($arrT[$y])),320,100,QTroof(QTcumul($arrT[$y])),2,true,$L['Backlog_cumul'],'','3');
  }
  echo '</td>',N;
  echo '</tr>',N;
  echo '</table>',N;
  
}
else
{
  echo '<p class="small">Graphs cannot be displayed because one of these files is missing: bin/qt_lib_graph.php, ',$_SESSION[QT]['skin_dir'].'/qtr_main2.css</p>';
}