<?php

// Q-registrations 2.5 build:20110627

$arrYears = array($y);
include('qtr_stats_inc_g.php');

// ------
// OUTPUT
// ------

if ( $ch['time']=='q' ) { $intWidth=16; } else { $intWidth=11; }

$pdf=new PDF();
$pdf->AliasNbPages();
$pdf->AddPage();
$pdf->SetTitle( PdfClean($L['Statistics']) );
$pdf->SetAuthor( PdfClean($_SESSION[QT]['site_name']) );
$pdf->SetSubject( PdfClean($L['H_Global']) );

$pdf->SetFont('Arial','B',14);
$pdf->SetTextColor(150);
$pdf->Ln();
$pdf->Cell(0, 10, PdfClean($L['H_Global']), 'T', 1, 'R');
$pdf->SetTextColor(0);

if ( $ch['time']=='q' ) { $intWidth=16; } else { $intWidth=11; }

// Title

$pdf->SetFont('Arial','B',10);
$pdf->Cell(0, 8, PdfClean($y.($s>=0 ? ' '.$oVIP->sections[$s] : '').($type=='I' ? ' '.$L['Inspections'] : '').(empty($tag) ? '' : ', '.$L['Tag_only'].' "'.str_replace(';','" '.$L['or'].' "',$tag).'"')),'', 1);

// Table

$arrTable = array();

// Table header

  $arrRow = array();
  $oCell = new cPdfCell(' ',28,5,'',true); $arrRow[]=$oCell;
  $oCell = new cPdfCell(' ',4, 5,'',true); $arrRow[]=$oCell;
  for ($i=1;$i<=$intMaxBt;$i++) { $oCell = new cPdfCell( $arrA[$i], $intWidth,5,'C',true); $arrRow[]=$oCell; }
  $oCell = new cPdfCell(($ch['time']=='d' ? '10 '.strtolower($L['Days']) : PdfClean($L['Year'])),$intWidth+3,5,'C',true); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;

// Table body topics

  $arrRow = array();
  $oCell = new cPdfCell($L['Topics'],28,5,'',true); $arrRow[]=$oCell;
  $oCell = new cPdfCell(' ',         4, 5,'',true,array(0,0,102)); $arrRow[]=$oCell;
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
  {
  $oCell = new cPdfCell((isset($arrT[$y][$intBt]) ? $arrT[$y][$intBt] : '0'),$intWidth); $arrRow[]=$oCell;
  }
  $oCell = new cPdfCell($arrTs[$y],$intWidth+3,5,'C');$oCell->font=array('Arial','B',8); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;

// Table body messages

  $arrRow = array();
  $oCell = new cPdfCell($L['Messages'],28,5,'',true); $arrRow[]=$oCell;
  $oCell = new cPdfCell(' ',4, 5,'',true,array(153,0,153)); $arrRow[]=$oCell;
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
  {
  $oCell = new cPdfCell((isset($arrM[$y][$intBt]) ? $arrM[$y][$intBt] : '0'),$intWidth); $arrRow[]=$oCell;
  }
  $oCell = new cPdfCell($arrMs[$y],$intWidth+3,5,'C');$oCell->font=array('Arial','B',8); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;

// Table body users

  $arrRow = array();
  $oCell = new cPdfCell($L['Users'].'*',28,5,'',true); $arrRow[]=$oCell;
  $oCell = new cPdfCell(' ',4, 5,'',true,array(0,153,153)); $arrRow[]=$oCell;
  for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
  {
  $oCell = new cPdfCell((isset($arrU[$y][$intBt]) ? $arrU[$y][$intBt] : '0'),$intWidth); $arrRow[]=$oCell;
  }
  $oCell = new cPdfCell($arrUs[$y],$intWidth+3,5,'C');$oCell->font=array('Arial','B',8); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;

// Show table
 
$pdf->BasicTable($arrTable);
$pdf->Ln(1);

// Note

$pdf->SetFont('Arial','',8);
$pdf->SetTextColor(0);
$pdf->Cell(0, 10, '* '.PdfClean($L['Distinct_users']), '', 1);
$pdf->Ln(5);

// After values display, change the null values to zero to be able to make charts

foreach($arrYears as $intYear)
{
$arrT[$intYear] = QTarrayzero($arrT[$intYear]);
$arrM[$intYear] = QTarrayzero($arrM[$intYear]);
$arrU[$intYear] = QTarrayzero($arrU[$intYear]);
}

// PCHART OR CHART

if ( file_exists('pChart/pChart.class') && file_exists('pChart/pData.class') && !isset($_GET['oldgraph']) )
{
  // Standard inclusions (cache cannot be used with pdf)
  include('pChart/pData.class');
  include('pChart/pChart.class');

  $lang = GetIso();
  // charttitle,abscise,dataset,datasetname,graphoptions,filename,color,cumul
  // note: language code is added to the filename to enable refreshing cached-graph when user change language.
  $strChart1 = QTpchart(
    $L['Topics_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrT[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'1'.$y.implode('',$ch).$lang,
    1);
  $strChart2 = QTpchart(
    $L['Topics_per_'.$ch['time'].'_cumul'].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrT[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'2'.$y.implode('',$ch).$lang,
    1,true); //cumul
  $strChart3 = QTpchart(
    $L['Replies_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrM[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'3'.$y.implode('',$ch).$lang,
    2);
  $strChart4 = QTpchart(
    $L['Users_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrU[$y] ),
    array( 'Serie1'=>$y ),
    $ch,
    $tt.'4'.$y.implode('',$ch).$lang,
    3);
    
  // Topics
  $pdf->Image($strChart1,10,$pdf->GetY(),90);
  $pdf->Image($strChart2,100,$pdf->GetY(),90);
  $pdf->SetY($pdf->GetY()+60);
  $pdf->Image($strChart3,10,$pdf->GetY(),90);
  $pdf->Image($strChart4,100,$pdf->GetY(),90);
  $pdf->SetY($pdf->GetY()+60);

}
elseif ( file_exists('bin/qt_lib_graph.php') && file_exists($_SESSION[QT]['skin_dir'].'/qtr_main2.css') )
{

  $y = $pdf->GetY();
  $x = $pdf->GetX();

  // Topics
  
  $intTopValue = QTroof($arrT[$y]);
  if ( $ch['value']=='a' ) 
  {
  $pdf = QTbarchartpdf($pdf,$arrT[$y],92,30,$intTopValue,2,true,$L['Topics_per_'.$ch['time']],'','1');
  }
  else
  {
  $pdf = QTbarchartpdf($pdf,$arrT[$y],92,30,$intTopValue,2,'P',$L['Topics_per_'.$ch['time']].' (%)','','1');
  }

  $pdf->SetXY($x+94,$y);

  $intTopValue = QTroof(QTcumul($arrT[$y]));
  if ( $ch['value']=='a' ) 
  {
  $pdf = QTbarchartpdf($pdf,QTcumul($arrT[$y]),92,30,$intTopValue,2,true,$L['Topics_per_'.$ch['time'].'_cumul'],'','1');
  }
  else
  {
  $pdf = QTbarchartpdf($pdf,QTcumul($arrT[$y]),92,30,$intTopValue,2,'P',$L['Topics_per_'.$ch['time'].'_cumul'].' (%)','','1');
  }

  $pdf->SetXY($x,$y+50);

  // Messages & Users
    
  $intTopValue = QTroof($arrM[$y]);
  if ( $ch['value']=='a' ) 
  {
  $pdf = QTbarchartpdf($pdf,$arrM[$y],92,30,$intTopValue,2,true,$L['Replies_per_'.$ch['time']],'','2');
  }
  else
  {
  $pdf = QTbarchartpdf($pdf,$arrM[$y],92,30,$intTopValue,2,'P',$L['Replies_per_'.$ch['time']].' (%)','','2');
  }

  $pdf->SetXY($x+94,$y+50);

  $intTopValue = QTroof($arrU[$y]);
  if ( $ch['value']=='a' ) 
  {
  $pdf = QTbarchartpdf($pdf,$arrU[$y],92,30,$intTopValue,2,true,$L['Users_per_'.$ch['time']],'','3');
  }
  else
  {
  $pdf = QTbarchartpdf($pdf,$arrU[$y],92,30,$intTopValue,2,'P',$L['Users_per_'.$ch['time']].' (%)','','3');
  }

}
else
{
  $pdf->SetFont('Arial','',8);
  $pdf->Cell(0, 10, PdfClean('Graphs cannot be displayed because one of these files is missing: bin/qt_lib_graph.php, '.$_SESSION[QT]['skin_dir'].'/qtr_main2.css'), 'T', 1);
}

// --------
// PDF END
// --------

$pdf->Output();

?>