<?php

// It is recommended to always use capital on first letter, script changes to lower case if necessary.
// The character doublequote ["] is FORBIDDEN (reserved for html tags)
// To make a single quote use slash [\']

// -------------
// TOP LEVEL VOCABULARY
// -------------

// Use the top level vocabulary to give the most appropriate name
// for the topics (object items) managed by this application.
// e.g. Ticket, Incident, Subject, Thread, Request, Faq,...

$L['Topic']='Ticket';
$L['Topics']='Tickets';

// The top level words are re-used in a lot of translations defined here after

// -------------
// VOCABULARY
// -------------

$L['i']='(?)';
$L['Y']='Ja';
$L['N']='Nee';
$L['Ok']='Ok';

$L['topic']=strtolower($L['Topic']);
$L['topics']=strtolower($L['Topics']);
$L['Topic_desc']='Beschrijving';
$L['Topic_add']='Nieuwe '.$L['topic'];
$L['Topic_del']=$L['Topic'].' verwijderen';
$L['Topic_man']=$L['Topics'].' beheren';

$L['Domain']='Domein';
  $L['Domains']='Domeinen';
$L['Section']='Sectie';
  $L['Sections']='Secties';
$L['User']='Gebruiker';
  $L['Users']='Gebruikers';
  $L['User_add']='Nieuwe gebruiker';
  $L['User_del']='Gebruiker verwijderen';
  $L['User_upd']='Profiel bewerken';
$L['Status']='Statuut';
  $L['Statuses']='Statuten';
$L['Sectiontab']='Tab sectie';
  $L['Sectiontabs']='Tabs secties';
$L['Member']='Lid';
  $L['Members']='Leden';
$L['Message']='Bericht';
  $L['Messages']='Berichten';
  $L['Message_deleted']='Bericht verwijderd...';
$L['Reply']='Antwoord';
  $L['Replys']='Antwoorden';
$L['Forward']='Verstuurd bericht';
  $L['Forwards']='verstuurd berichten';
$L['News']='Info';
  $L['Newss']='Infos'; // In other languages: News=One news, Newss=Several news
  $L['News_stamp']='Nieuws: ';
$L['Inspection']='Inspectie';
  $L['Inspections']='Inspecties';
$L['Field']='Veld';
  $L['Fields']='Velden';
$L['Attachment']='Attachment';
$L['Notify_also']='Op de hoogte brengen';
$L['Drop_attachment']='Attachment wegnemen';
$L['Eventdate']='Incident&nbsp;datum';
$L['Eventtime']='Incident&nbsp;uur';
$L['H_Eventdate']='jjjj-mm-dd';
$L['H_Eventtime']='uu:mm';
$L['Wisheddate']='Oplevering';
$L['H_Wisheddate']='jjjj-mm-dd';
$L['Ref']='Ref.';
$L['Title']='Titel';
$L['Smiley']='Voorvoegsel';
$L['Notification']='Nota';
$L['Username']='Gebruikersnaam';
  $L['Userrole']['A']='Administrateur'; $L['Userroles']['A']='Administrateurs';
  $L['Userrole']['M']='Staff';          $L['Userroles']['M']='Staffs';
  $L['Userrole']['U']='Gebruiker';      $L['Userroles']['U']='Gebruikers';
  $L['Userrole']['V']='Bezoeker';       $L['Userroles']['V']='Bezoekers';
  $L['Userrole_MF']='Sectie moderator';
  $L['Userrole_MA']='Acteur';
  $L['Userrole_UN']='Gebruiker op de hoogte';
$L['Joined']='Geregistreerd op';
$L['Avatar']='Foto';
$L['Signature']='Onderschrift';
$L['Role']='Rang';
$L['Topic_starter']='Gerapporteerd&nbsp;door';
$L['Topic_info']='Feiten';
$L['Deleted_by']='Geschrapt door';
$L['Modified_by']='Bewerkt door';
$L['Top_participants']='Top deelnemers';

// Common

$L['Add']='Toevoegen';
$L['Advanced_reply']='Voorproef...';
$L['All']='Alles';
$L['Author']='Auteur';
$L['By']='Door';
$L['Change']='Bewerk';
$L['Change_name']='Gebruikersnaam veranderen...';
$L['Change_status']='Statuut veranderen...';
$L['Change_type']='Type veranderen...';
$L['Changed']='Bewerkt';
$L['Close']='Afsluiten';
$L['Closed']='Gesloten';
$L['Contact']='Contact';
$L['Containing']='Bevat';
$L['Continue']='Voortduren';
$L['Coord']='Co&ouml;rdinaten';
$L['Coord_latlon']='(lat,lon)';
$L['Csv']='Export'; $L['H_Csv']='Open in spreadsheet';
$L['Date']='Datum';
$L['Dates']='Datum';
$L['Day']='Dag';
$L['Days']='Dagen';
$L['Delete']='Uitwissen';
$L['Delete_tags']='Verwijderen (click een woord of type * om alles te verwijderen)';
$L['Destination']='Bestemming';
$L['Details']='Details';
$L['Display_at']='Tonen op datum van';
$L['Edit']='Bewerken';
$L['Email']='E-mail'; $L['No_Email']='Geen e-mail';
$L['Exit']='Uitrit';
$L['First']='Eerste';
$L['Goodbye']='U bent uitgelogd... Tot ziens';
$L['Goto']='Ga naar';
$L['H_Website']='Uw website url (met http://)';
$L['Help']='Hulp';
$L['Hidden']='Verborgen';
$L['I_wrote']='Ik schreef';
$L['Information']='Informatie';
$L['Last']='Laatste';
$L['Legend']='Legend';
$L['Location']='Plaats';
$L['Maximum']='Maximum';
$L['Minimum']='Minimum';
$L['Missing']='Ontbrekende informatie';
$L['Modified']='Verandered';
$L['More']='Meer';
$L['Month']='Maand';
$L['Next']='Volgende';
$L['None']='Niets';
$L['Options']='Opties';
$L['Other']='Andere';
$L['or']='of'; // must be in lowercase
$L['Page']='pagina';
$L['Pages']='pagina\'s';
$L['Password']='Wachtwoord';
$L['Picture']='Foto';
$L['Phone']='Telefoon';
$L['Preview']='Voorproef';
$L['Previous']='Vorige';
$L['Privacy']='Priv&eacute;-leven';
$L['Reason']='Reden';
$L['Remove']='Uitwissen';
$L['Rename']='Benoemen';
$L['Result']='Resultaat';
$L['Results']='Resultaten';
$L['Save']='Opslaan';
$L['Score']='Score';
$L['Seconds']='Seconden';
$L['Selected_from']='geselecteerd uit';
$L['Send']='Zenden';
$L['Send_on_behalf']='Zenden namens';
$L['Statistics']='Statistieken';
$L['Style']='Stijl';
$L['Tag']='Categorie';
$L['Tags']='Categorie&euml;n';
$L['Time']='Uur';
$L['Total']='Totaal';
$L['Type']='Tijp';
$L['Unknown']='Onbekend';
$L['Views']='Bekeken';
$L['Website']='Website'; $L['No_Website']='Geen website';
$L['Welcome']='Welkom';
$L['Welcome_to']='Welkom voor een nieuwe gebruiker, ';
$L['Welcome_not']='Ik ben %s niet !';
$L['Year']='Jaar';

// Menu

$L['FAQ']='FAQ';
$L['Search']='Zoeken';
$L['Memberlist']='Gebruikerslijst';
$L['Login']='Inloggen';
$L['Logout']='Uitloggen';
$L['Register']='Registreer';
$L['Profile']='Profiel';
$L['Administration']='Administratie';
$L['Legal']='Privacy';
$L['Coppa_form']='Coppa&nbsp;vorm';

// Section // use &nbsp; to avoid double ligne buttons

$L['Post_new_topic']='Nieuwe&nbsp;'.$L['topic'];
$L['Post_reply']='Antwoord';
$L['Topic_closed']='Gesloten&nbsp;'.$L['topic'];
$L['First_message']='Eerste&nbsp;bericht';
$L['Last_message']='Laatste&nbsp;bericht';
$L['Goto_message']='[<b>&raquo;</b>]';
$L['H_Goto_message']='Laatste&nbsp;bericht';

$L['My_last_topic']='Mijn&nbsp;laatste&nbsp;'.$L['topic'];
$L['All_my_topics']='Mijn&nbsp;'.$L['topics'];
$L['All_my_assigned']='Mijn&nbsp;taken';
$L['Topic_handled']=$L['Topic'].' behandeld';
$L['Topics_handled']=$L['Topics'].' behandeld';
$L['Topic_forwarded']=$L['Topic'].' is naar %s gestruurd.';

$L['You_reply']='Ik antwoord';
$L['Quote']='Quote';
$L['Move']='Verplaatsen';
$L['Move_to']='Verplaatsen';
$L['Change_actor']='Werknemer';
$L['Close_my_topic']='Ik sluit mijn '.$L['topic'];

$L['Quick_reply']='Snel&nbsp;antwoord';
$L['Previous_replies']='Vorige berichten';
$L['Close_topic']='Sluit dit '.$L['topic'];
$L['Edit_message']='Bewerk bericht';
$L['Delete_message']='Verwijder bericht';

$L['Move_keep']='Houd origineel nummer';
$L['Move_reset']='Verwijzingen naar 0';
$L['Move_follow']='Volgt sectienummer';

$L['Edit_start']='Wijziging beginnen';
$L['Edit_stop']='Wijziging stoppen';
$L['Document_add']='Nieuwe document';
$L['Document_name']='Document naam';

$L['Topic_closed_show']='Gesloten aanvragen: tonen';
$L['Topic_closed_hide']='Gesloten aanvragen: verborgen';
$L['Topic_news_show']='Nieuws: tonen';
$L['Topic_news_hide']='Nieuws: verborgen';
$L['Topic_show_all']='Alle secties verzamelen';
$L['Topic_show_this']='Alleen dit sectie tonen';
$L['Last_column']='Extra colonne';

$L['Helpframe_show']='Hulp pagina tonen';
$L['Helpframe_hide']='Hulp pagina verbergen';
$L['Helpframe_refresh']='Hulp pagina verfrissen';
$L['Helpframe_window']='Tonen in een nieuw venster';

// Search

$L['Recent_messages']='Recente&nbsp;'.$L['topics'];
$L['All_news']='Alle&nbsp;mededelingen';
$L['All_my_topics']='Alle&nbsp;mijn&nbsp;'.$L['topics'];

$L['Advanced_search']='Geavanceerd onderzoek';
$L['H_Advanced']='(een tiketnummer of een woord)';
$L['Keywords']='Sleutelwoord(en)';
$L['Search_option']='Onderzoeksoptie';
$L['Search_criteria']='Onderzoekscriterium';
$L['Search_by_db']='Zoeken in velden';
$L['Search_by_key']='Zoeken met woord(en)';
$L['Search_by_ref']='Zoeken met nummer';
$L['Search_by_status']='Zoeken met statuut';
$L['Search_by_data']='Zoeken in veld';
$L['Search_result']='Resultaat van het onderzoek';
$L['In_title_only']='In titel alleen';
$L['In_all_sections']='In alle secties';
$L['Any_time']='Alle tijd';
$L['Any_type']='Alle tijp';
$L['Any_status']='Alle statuut';
$L['H_Reference']='(het numerieke deel)';
$L['Too_many_keys']='Te veel woorden';
$L['Search_by_words']='Elk woord afzonderlijk zoeken';
$L['Search_exact_words']='Worden samen zoeken';
$L['This_week']='Deze week';
$L['This_month']='Deze maand';
$L['This_year']='Dit jaar';
$L['Withtag']= 'Met categorie';
$L['Show_only_tag']='Tonen alleen deze met categorie';
$L['Search_tag']='Zoeken naar tickets met categorie';
$L['Tag_only']='alleen met categorie'; // must be in lowercase
$L['H_Tag_input']='Met de kommapunt, kunt u verschillende categorie&euml;n invoeren (b.v.: c1;c2 betekend tickets met categorie "c1" of "c2").';

// Inspection

$L['I_level']='Antworden waarden';
$L['I_aggregation']='Samenvoeging methode';
$L['I_closed']='Gesloten inspectie';
$L['I_running']='Lopende inspectie';
$L['I_v_mean']='Gemiddelde waarde';
$L['I_v_first']='Eerste waarde';
$L['I_v_last']='Laatste waarde';
$L['I_v_max']='Maximum';
$L['I_v_min']='Minimum';
$L['I_r_no']='Nee';
$L['I_r_yes']='Ja';
$L['I_r_bad']='Slecht';
$L['I_r_medium']='Middel';
$L['I_r_good']='Goed';
$L['I_r_verylow']='Zeer laag';
$L['I_r_low']='Laag';
$L['I_r_high']='Hoog';
$L['I_r_veryhigh']='Zeer hoog';

// Privacy

$L['Privacy_visible'][0]='Verborgen';
$L['Privacy_visible'][1]='Zichtbaar voor leden alleen';
$L['Privacy_visible'][2]='Zichtbaar voor iedereen';

// Restrictions

$L['R_member']='De toegang is beperkt tot slechts leden.<br/><br/>Gelieve in te loggen, of ga naar Registreerd om lid te worden.';
$L['R_staff']='De toegang is beperkt tot slechts staff. <a href="qtr_index.php">Exit</a>';
$L['R_security']='De veiligheid instellingen laten deze functie geen toe.';
$L['R_default']='Dit is de standaardwaarde. Controleer als het correct is.';
$L['R_format']='De huidige waarde heeft een verkeerd formaat. De verandering zou noodzakelijk zijn.';

// Errors

$L['E_already_used']='Reeds gebruikt';
$L['E_char_max']='(maximum %d tekens)';
$L['E_editing']='Data zijn verandered. Verlaten zonder saven?';
$L['E_file_size']='Het bestand is te groot';
$L['E_javamail']='Veiligheid: java is nodig om e-mail te zien';
$L['E_line_max']='(maximum %d lijnen)';
$L['E_no_desc']='Geen beschrijving';
$L['E_no_public_section']='Dit sectie bevat geen openbaar '.$L['topic'].'. De priv&eacute;sectie toegang vereist login.';
$L['E_no_result']='Geen r&eacute;sultaat';
$L['E_no_title']='Een titel is verplicht';
$L['E_no_topic']='Geen '.$L['topic'].' gevond';
$L['E_no_visible_section']='Dit systeem bevat geen sectie zichtbaar voor u.';
$L['E_ref_search']='Decimaal (of komma) niet geldig. Het gebruik aanhalingsteken als u een aantal als sleutelwoord wilt zoeken.';
$L['E_section_closed']='Sectie&nbsp;is&nbsp;gesloten'; // use &nbsp; as space to avoid double ligne buttons
$L['E_text']='Probleem met uw bericht.';
$L['E_too_long']='Te lang bericht';
$L['E_too_much']='Te veel berichten vandaag...<br/><br/>Om veiligheidsredenen, is de aantallen toegestane posten beperkt. Probeer opnieuw morgen. Bedankt...';
$L['E_wait']='Gelieve te wachten een paar seconden';

// Success

$L['S_update']='Voltooide update...';
$L['S_delete']='Schrap voltooid...';
$L['S_insert']='Succesvolle verwezenlijking...';
$L['S_save']='Opslaan voltooid...';
$L['S_message_saved']='Bericht opgeslagen...<br/>Dank u';

// Date time
/*
MMM or DDD means the full name
MM or DD means short name
M or D means 1 character abbreviation

dateMMM dateDDD: can have accent symbol
dateMM  dateDD:  cannot have accent and each word must be unic (e.g. Ma,Ju,Ju,Au not allowed)
dateM   dateD:   cannot have accent and can have duplicates
index 1 must be JANUARY or MONDAY
*/
$L['dateMMM']=array(1=>'Januari','Februari','Maart','April','Mei','Juni','Juli','Augustus','Septembre','Oktober','November','December');
$L['dateMM'] =array(1=>'Jan','Feb','Mrt','Apr','Mei','Jun','Jul','Aug','Sep','Okt','Nov','Dec');
$L['dateM']  =array(1=>'J','F','M','A','M','J','J','A','S','O','N','D');
$L['dateDDD']=array(1=>'Maandag','Dinsdag','Woensdag','Donderdag','Vrijdag','Zaterdag','Zondag');
$L['dateDD'] =array(1=>'Ma','Di','Wo','Do','Vr','Za','Zo');
$L['dateD']  =array(1=>'M','D','W','D','V','Z','Z');
$L['dateSQL']=array(
  'January'  => 'januari',
  'February' => 'februari',
  'March'    => 'maart',
  'April'    => 'april',
  'May'      => 'mei',
  'June'     => 'juni',
  'July'     => 'juli',
  'August'   => 'augustus',
  'September'=> 'september',
  'October'  => 'oktober',
  'November' => 'november',
  'December' => 'december',
  'Monday'   => 'maandag',
  'Tuesday'  => 'dinsdag',
  'Wednesday'=> 'woensdag',
  'Thursday' => 'donderdag',
  'Friday'   => 'vrijdag',
  'Saturday' => 'zaterdag',
  'Sunday'   => 'zondag',
  'Today'=>'Vandaag',
  'Yesterday'=>'Gisteren',
  'Now'=> 'Nu',
  'Jan'=>'jan',
  'Feb'=>'feb',
  'Mar'=>'mrt',
  'Apr'=>'apr',
  'May'=>'mei',
  'Jun'=>'jun',
  'Jul'=>'jul',
  'Aug'=>'aug',
  'Sep'=>'sep',
  'Oct'=>'okt',
  'Nov'=>'nov',
  'Dec'=>'dec',
  'Mon'=>'ma',
  'Tue'=>'di',
  'Wed'=>'wo',
  'Thu'=>'do',
  'Fri'=>'vr',
  'Sat'=>'za',
  'Sun'=>'zo');

// HTML header language setting

if ( !defined('QTR_HTML_DTD') ) define ('QTR_HTML_DTD', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
if ( !defined('QTR_HTML_CHAR') ) define ('QTR_HTML_CHAR', 'iso-8859-1');
if ( !defined('QTR_HTML_DIR') ) define ('QTR_HTML_DIR', 'ltr');
if ( !defined('QTR_HTML_LANG') ) define ('QTR_HTML_LANG', 'nl');