<?php

// Q-registerations 2.5 build:20110627

include('bin/qt_lib_txt.php');
include('bin/qt_lib_db.php');
include('bin/qtr_fn_base.php');

// Protection against injection (accept only 3 'lang')
$id = strip_tags($_POST['id']);
$lang = strip_tags($_POST['lang']);
if ( !in_array($lang,array('language/english','language/francais','language/nederlands')) ) $lang = 'language/english';

$id = intval(substr($id,1));
 
include($lang.'/qtr_main.php');
include('bin/config.php');

$oDBAJAX = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);
if ( !empty($oDBAJAX->error) ) exit;

// query

$oDBAJAX->Query('SELECT t.*,p.icon,p.title,p.icon as smile,p.textmsg FROM ('.$qtr_prefix.'qtrtopic t INNER JOIN '.$qtr_prefix.'qtrpost p ON t.firstpostid = p.id) WHERE t.id='.$id);
$row = $oDBAJAX->GetRow();
$row['title'] = QTconv(stripslashes($row['title']),'-4');
$row['textmsg'] = QTconv(stripslashes($row['textmsg']),'-4');

$oDBAJAX->Query('SELECT * FROM '.$qtr_prefix.'qtrsection f WHERE f.id='.$row['section']);
$row2 = $oDBAJAX->GetRow();

//output the response
echo '<p class="preview_section">',$L['Section'],': ',stripslashes($row2['title']),'</p>';
echo '<div class="preview"><p class="preview_title">';
if ( $row2['numfield']!='N' )
{
  printf($row2['numfield'],$row['numid']);
  echo '<br/>';
}
echo htmlentities($row['title'],ENT_NOQUOTES),'</p>';

echo '<p class="preview_message">',htmlentities(QTcompact(QTunbbc($row['textmsg']),250,' '),ENT_NOQUOTES),'</p>';
echo '<p class="preview_user">',$row['firstpostname'],'</p></div>';
echo '<p class="preview_date">',QTdatestr($row['firstpostdate'],'M d','(H:i)'),'</p>';
if ( $row['actorid']>=0 ) echo '<p class="preview_date">',$L['Userrole_MA'],': ',$row['actorname'],'</p>';

?>